#include <torch/torch.h>
#include <torch/script.h>

#include <iostream>
#include <memory>

extern "C" {
 void ANNpredict(float* output, float* input_0, float* input_1, float* input_2, float* input_3, float* input_4) {   // const perché input all'interno non viene modificato 

  auto data_0 = torch::from_blob(&input_0, {8}, torch::kFloat);
  auto data_1 = torch::from_blob(&input_1, {8}, torch::kFloat);
  auto data_2 = torch::from_blob(&input_2, {8}, torch::kFloat);
  auto data_3 = torch::from_blob(&input_3, {8}, torch::kFloat);
  auto data_4 = torch::from_blob(&input_4, {8}, torch::kFloat);

  // auto std_0 = torch::from_blob(&std, {8}, torch::kFloat);
  // auto mean_0 = torch::from_blob(&mean, {8}, torch::kFloat);

  std::vector<torch::Tensor> data_list = {data_0, data_1, data_2, data_3, data_4};
  auto data = torch::stack(data_list, 0);

  auto mean = data.mean(0);
  auto std = data.std(0);

  // Norm data tensor creation
  std::vector<torch::jit::IValue> normalized_input;
  torch::Tensor normalized_data = torch::empty({5, 8});

  // Normalization
  for (int t = 0; t < data.size(1); ++t) {
    // Iter over all points
    for (int i = 0; i < data.size(0); ++i) {
      // Norm procedure: (data_timestep - mean) / stddev
      normalized_data.index({i, t}) = (data.index({i, t}) - mean.index({t})) / std.index({t});
    }
  }

  torch::jit::script::Module module;
  // Deserialize the ScriptModule from a file using torch::jit::load().
  module = torch::jit::load("/home/cenvinzf@coria.fr/workdir/full_coupling/case1/model.pt");

  // Execute the model and turn its output into a tensor.
  normalized_input.push_back(normalized_data.unsqueeze(0));
  at::Tensor outputs = module.forward(normalized_input).toTensor();

  // Denormalization step
  for (int t = 0; t < data.size(1); ++t) {
    outputs.index({t}) = (outputs.index({t}) * std.index({t})) + mean.index({t});
  }

  // Conversion to C++ array
  float* outputANN;
  float* data_ptr = outputs.data_ptr<float>();
  for (int t = 0; t < data.size(1); ++t) {
    outputANN[t] = data_ptr[t];
  }

  // Collecting ANN output
  for (int t = 0; t < data.size(1); ++t) {
    output[t] = outputANN[t];
  }
 }
}

int main () {
  return 0;
}